赞
踩
给定一个数组,它的第 i 个元素是一支给定的股票在第 i 天的价格。
设计一个算法来计算你所能获取的最大利润。你最多可以完成 两笔 交易。
注意: 你不能同时参与多笔交易(你必须在再次购买前出售掉之前的股票)。
示例 1:
输入: [3,3,5,0,0,3,1,4]
输出: 6
解释: 在第 4 天(股票价格 = 0)的时候买入,在第 6 天(股票价格 = 3)的时候卖出,这笔交易所能获得利润 = 3-0 = 3 。
随后,在第 7 天(股票价格 = 1)的时候买入,在第 8 天 (股票价格 = 4)的时候卖出,这笔交易所能获得利润 = 4-1 = 3 。
示例 2:
输入: [1,2,3,4,5]
输出: 4
解释: 在第 1 天(股票价格 = 1)的时候买入,在第 5 天 (股票价格 = 5)的时候卖出, 这笔交易所能获得利润 = 5-1 = 4 。
注意你不能在第 1 天和第 2 天接连购买股票,之后再将它们卖出。
因为这样属于同时参与了多笔交易,你必须在再次购买前出售掉之前的股票。
示例 3:
输入: [7,6,4,3,1]
输出: 0
解释: 在这个情况下, 没有交易完成, 所以最大利润为 0。
来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/best-time-to-buy-and-sell-stock-iii
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。
感谢王尼玛的五种实现+详细图解 123.买卖股票的最佳时机 III,labuladong的一个方法团灭 6 道股票问题
k=2范围较小,可以穷举,不用for循环
dp[i][2][0] = max(dp[i - 1][2][0], dp[i - 1][2][1] + prices[i]);
dp[i][2][1] = max(dp[i - 1][2][1], dp[i - 1][1][0] - prices[i]);
dp[i][1][0] = max(dp[i - 1][1][0], dp[i - 1][1][1] + prices[i]);
dp[i][1][1] = max(dp[i - 1][1][1], dp[i - 1][0][0] - prices[i]);
= max(dp[i - 1][1][1], -prices[i]);
- class Solution {
- public int maxProfit(int[] prices) {
- // return maxProfitI(prices);
- // return maxProfitII(prices);
- // return maxProfitIII(prices);
- return maxProfitIV(prices);
- }
-
- //方法四:基于方法三优化,dp[i][k][j]只跟前一天的数据有关,可以直接定义变量解决
- //时间复杂度O(n),空间复杂度O(1)
- private int maxProfitIV(int[] prices) {
- if (prices == null || prices.length == 0) {
- return 0;
- }
- int dpi_10 = 0;
- int dpi_11 = -prices[0];
- int dpi_20 = 0;
- int dpi_21 = -prices[0];
- for (int i = 1; i < prices.length; i++) {
- dpi_10 = Math.max(dpi_10, dpi_11 + prices[i]);
- dpi_11 = Math.max(dpi_11, - prices[i]);
- dpi_20 = Math.max(dpi_20, dpi_21 + prices[i]);
- dpi_21 = Math.max(dpi_21, dpi_10 - prices[i]);
- }
- return dpi_20;
- }
-
- //方法三:基于方法二
- //k=2范围较小,可以直接穷举,不用遍历
- //时间复杂度O(n),空间复杂度O(n)
- private int maxProfitIII(int[] prices) {
- if (prices == null || prices.length == 0) {
- return 0;
- }
- int len = prices.length;
- int[][][] dp = new int[len][3][2];
- dp[0][1][0] = 0;
- dp[0][2][0] = 0;
- dp[0][1][1] = -prices[0];
- //先买入和卖出一次,再买入一次,其实就相当于买入一次
- dp[0][2][1] = -prices[0];
- for (int i = 1; i < len; i++) {
- dp[i][1][0] = Math.max(dp[i - 1][1][0], dp[i - 1][1][1] + prices[i]);
- dp[i][1][1] = Math.max(dp[i - 1][1][1], - prices[i]);
- dp[i][2][0] = Math.max(dp[i - 1][2][0], dp[i - 1][2][1] + prices[i]);
- dp[i][2][1] = Math.max(dp[i - 1][2][1], dp[i - 1][1][0] - prices[i]);
- }
- return dp[len - 1][2][0];
- }
-
- //方法二:动态规划
- //定义三维dp数组dp[i][k][j],穷举所有可能求最值
- //时间复杂度O(kn),空间复杂度O(2kn)
- private int maxProfitII(int[] prices) {
- if (prices == null || prices.length == 0) {
- return 0;
- }
- int len = prices.length;
- int maxK = 2;
- int[][][] dp = new int[len][maxK + 1][2];
- for (int i = 0; i < len; i++) {
- for (int k = maxK; k >= 1; k--) {
- if (i == 0) {
- dp[i][k][0] = 0;
- dp[i][k][1] = -prices[i];
- continue;
- }
- dp[i][k][0] = Math.max(dp[i - 1][k][0], dp[i - 1][k][1] + prices[i]);
- dp[i][k][1] = Math.max(dp[i - 1][k][1], dp[i - 1][k - 1][0] - prices[i]);
- }
- }
- return dp[len - 1][maxK][0];
- }
-
- //方法一:递归+备忘录
- //定义递归函数dfs(prices,index,status,k)表示第i天状态为status(持有/不持有)至今最多进行k次交易能够获取的最大利润
- //时间复杂度O(n),空间复杂度O(n)
- private int maxProfitI(int[] prices) {
- if (prices == null || prices.length == 0) {
- return 0;
- }
- Map<String, Integer> memoMap = new HashMap<>();
- return dfs(prices, prices.length - 1, 0, 2, memoMap);
- }
-
- private int dfs(int[] prices, int index, int status, int k, Map<String, Integer> memoMap) {
- if (index < 0 || k == 0) {
- return status == 1 ? Integer.MIN_VALUE : 0;
- }
- String key = index + "*" + status + "*" + k;
- if (memoMap.containsKey(key)) {
- return memoMap.get(key);
- }
- int res;
- if (status == 1) {
- res = Math.max(dfs(prices, index - 1, 1, k, memoMap),
- dfs(prices, index - 1, 0, k - 1, memoMap) - prices[index]);
- } else {
- res = Math.max(dfs(prices, index - 1, 0, k, memoMap),
- dfs(prices, index - 1, 1, k, memoMap) + prices[index]);
- }
- memoMap.put(key, res);
- return res;
- }
- }
Copyright © 2003-2013 www.wpsshop.cn 版权所有,并保留所有权利。